<?php 
//written by Daevid Vincent (http://daevid.com) daevid@daevid.com

////////////////////////////////////////////////////
//						DEVICES					  //
////////////////////////////////////////////////////

class device
{
	protected $IP;
	protected $MAC;
	protected $name;
	public $interface;
	public $image = "computer";
	
	public $incomplete = false;
	public $active_nmap = false;
	public $active_ping = false;

	public $lease_start;
	public $lease_end;

    function __construct ( $IP, $MAC, $name, $interface, $incomplete, $test ) 
	{
        $this->IP = $IP;
        $this->MAC = strtoupper($MAC);
        $this->name = $name;
        $this->interface = $interface;
        $this->incomplete = $incomplete;

		if ($test)
		{
			if ( $this->active_ping() == false )
				 // if ping fails, break out the big guns and try nmap, as the box could still be online
				  $this->active_nMap();
			else //we _assume_ that if we can ping it, then we can nmap it too, so save the time and trouble
				 $this->active_nmap = true;
		}
    }

    function getIP() 
	{
        return $this->IP;
    }

    function getMAC() 
	{
        return $this->MAC;
    }

    function getName() 
	{
        return $this->name;
    }

    function setName($name) 
	{
        $this->name = $name;
    }

    function getInterface() 
	{
        return $this->interface;
    }


    function setImage($newImage) 
	{
        $this->image = $newImage;
    }

    function getImage() 
	{
        return $this->image;
    }


    function setLease($start, $end) 
	{
        $this->lease_start = $start;
        $this->lease_end = $end;
    }

	function active_nMap()
	{
		$test = exec("/usr/bin/nmap -sP ".$this->IP);
		if ( strstr($test,"1 host up") ) 
			$this->active_nmap = true;
		else
			$this->active_nmap = false;

		return $this->active_nmap;
	}

	function active_ping()
	{
		$test = `ping -n -c 1 -w 1 -q $this->IP`;
		if ( strstr($test,"100% loss") ) 
			$this->active_ping = false;
		else
			$this->active_ping = true;

		return $this->active_ping;
	}

	/*
	function active_ping_exit()
	{
		//http://us3.php.net/manual/en/function.system.php
		$test = system("ping -n -c 1 -w 1 -q $this->IP", $code);
		if ( $code == 0 ) 
			$this->active = true;
		else
			$this->active = false;

		return $this->active;
	}
	*/

}

////////////////////////////////////////////////////
//					INTERFACES					  //
////////////////////////////////////////////////////
class interfaceX
{
    public $IP;
    public $MAC;
    public $name;
	
    function __construct ( $IP, $MAC, $name ) 
    {
        $this->IP = $IP;
        $this->MAC = $MAC;
        $this->name = $name;
    }
}
?>
